#include <iostream>
#include <stdio.h>
#include <rt.h>


#include <opencv2/opencv.hpp>

typedef	QWORD UINT64;
typedef QWORD LARGE_INTEGER;

#define QueryPerformanceCounter QueryRtPerformanceCounter
#define QueryPerformanceFrequency QueryRtPerformanceFrequency

using namespace std;

// v
#define	CNT_RTCVDIAG_MEASURE		3000
// vԏ
enum enRtCvDiagMeasureTime
{
	enRtCvDiagMeasureTimeGrab = 0,			//  (gp) 
	enRtCvDiagMeasureTimeMat,				// MatN[JnCPUJE^l
	enRtCvDiagMeasureTimeResize,			// MatTCYJnCPUJE^l
	enRtCvDiagMeasureTimeGray,				// O[XP[JnCPUJE^l
	enRtCvDiagMeasureTimeOpencv,			// CannyJnCPUJE^l
	enRtCvDiagMeasureTimeEnd,				// ȀICPUJE^l
	enRtCvDiagMeasureTimeCount				// v̌
};
// v
typedef struct _ST_RTCVDIAG_MEASURE
{
	DWORD			dwCamWidth;								// J摜̕
	DWORD			dwCamHeight;							// J摜̍
	DWORD			dwCamChannel;							// J摜̃`l
	DWORD			dwMatWidth;								// TCYMat̕
	DWORD			dwMatHeight;							// TCYMat̍
	DWORD			dwMatChannel;							// TCYMat̃`l
	UINT64			doTime[enRtCvDiagMeasureTimeCount];		// v
}	ST_RTCVDIAG_MEASURE;
// ff񃁃\
typedef	struct _ST_RTCVDIAG
{
	DWORD			dwLine;									// g[Xʒu(__LINE__)
	DWORD			dwType;									// v
	double			doResize;								// TCYۂ̏搔
	ST_RTCVDIAG_MEASURE		stMeasure[CNT_RTCVDIAG_MEASURE];			// v
	// FKvɉĒǉ
}	ST_RTCVDIAG;
ST_RTCVDIAG*		m_stRtCvDiag;

// C[W񃁃\
typedef struct _TG_VIDEOCAPTURE_IMAGE
{
	// C[W(px)
	uint32_t Width;
	// C[W(px)
	uint32_t Height;
	// C[W`l
	uint32_t Channel;
}	ST_VIDEOCAPTURE_IMAGE;
ST_VIDEOCAPTURE_IMAGE*			m_stRtCvImg;

#define	__RUN__				m_stRtCvDiag->dwLine = __LINE__;

// VXeNpX
static	char		szBootPath[512];

// CPUNbNJE^̎擾iSpeedStep@\̂CPUł͗pł܂j
_inline UINT64 GetCPUCounter(void)
{
	_asm    rdtsc
}


// XgbvEHb`Jn
LARGE_INTEGER		qwStart;
void fnStopWatchStart()
{
	QueryPerformanceCounter(&qwStart);
}

// XgbvEHb`~
LARGE_INTEGER		qwStop;
void fnStopWatchStop()
{
	QueryPerformanceCounter(&qwStop);
}

LARGE_INTEGER		qwFreq;
void fnStopWatchInit()
{
	QueryPerformanceFrequency(&qwFreq);
}

double fnStopWatchGetMicrosec()
{
	return (double)((qwStop - qwStart) * 1000000L) / (double)qwFreq;
}


// vf[^̕ۑ
void fnSaveRtCvMeasure()
{
	time_t				tv;
	struct tm			_tm;
	struct tm*			tm = &_tm;

	FILE*		fp;
	errno_t		eno;
	char		chPath[512];
	int32_t		inCnt;

	printf("I$[%04d]RtCv measure save start \n", __LINE__);

	// ݎ擾
	time(&tv);
	localtime_s(&tv, tm);

	// t@C
	sprintf_s(chPath, sizeof(chPath), "%s%04d%02d%02d%02d%02d%02d_NtCvMeasure.csv", szBootPath,
		tm->tm_year + 1900, tm->tm_mon + 1, tm->tm_mday,
		tm->tm_hour, tm->tm_min, tm->tm_sec);

	// t@CI[v(VK)
	eno = fopen_s(&fp, chPath, "wt");
	if (eno != 0)
	{
		// t@CI[vs
		printf("E$[%04d]NtCv open save file %d\n", __LINE__, eno);
		return;
	}

	// wb_o
	fprintf_s(fp,	"Count,PngRead,ResizeMat,Gray,Edge,End\n");

	// f[^o
	for (inCnt = 0; inCnt < CNT_RTCVDIAG_MEASURE; inCnt++)
	{
		fprintf_s(fp, "%d,%lld,%lld,%lld,%lld,%lld\n",
			inCnt,
			m_stRtCvDiag->stMeasure[inCnt].doTime[enRtCvDiagMeasureTimeMat],
			m_stRtCvDiag->stMeasure[inCnt].doTime[enRtCvDiagMeasureTimeResize],
			m_stRtCvDiag->stMeasure[inCnt].doTime[enRtCvDiagMeasureTimeGray],
			m_stRtCvDiag->stMeasure[inCnt].doTime[enRtCvDiagMeasureTimeOpencv],
			m_stRtCvDiag->stMeasure[inCnt].doTime[enRtCvDiagMeasureTimeEnd]);
	}

	// t@CN[Y
	fclose(fp);

	printf("I$[%04d]NtCv measure save finish \n", __LINE__);

}

// Î~̘AGbWoeXg
void		fnKey201()
{
	int32_t inRet = 0;
	int32_t inCnt = 0;
	cv::Mat img_org;		// imread̃IWi摜
	cv::Mat img;			// ؗpɉ摜C

	// GbWo臒l
	double	doThres1 = 50.0;
	double	doThres2 = 110.0;
	// TCY̏搔
	m_stRtCvDiag->doResize = 0.5;

	__RUN__;
	// v񏉊
	memset(m_stRtCvDiag->stMeasure, 0, sizeof(ST_RTCVDIAG_MEASURE)*CNT_RTCVDIAG_MEASURE);
	// ReBj[񐔏
	int32_t inContinue = 100;
	printf("I$[%04d]RtCv Measure start \n", __LINE__);

	// --------------------------------------
	// pngǂݍ
	// --------------------------------------
	while (inContinue > 0)
	{
		img_org = cv::imread("C:\\temp\\Image.png");
		if (img_org.empty()) {					// ǂݍݎs
			inContinue--;						// ReBj[񐔃fNg
			// ǂݍݎs̏ꍇ̓gC
			if (1 < inContinue) {				// ReBj[񐔔
				continue;						// v蒼
			}
			else {
				printf("E$[%04d] imread \n", __LINE__);
				return;							// w񐔓ǂݍݎŝߏI
			}
		}
		else {									// ǂݍݐ
			break;
		}
	}

	// Av
	while (inCnt < CNT_RTCVDIAG_MEASURE)
	{
		// --------------------------------------
		// N[쐬
		// --------------------------------------
		m_stRtCvDiag->stMeasure[inCnt].doTime[enRtCvDiagMeasureTimeMat] = GetCPUCounter();
		img = img_org.clone();

		// --------------------------------------
		// J摜̐ݒ
		// --------------------------------------
		m_stRtCvImg->Width = img.cols;
		m_stRtCvImg->Height = img.rows;
		m_stRtCvImg->Channel = img.channels();
		m_stRtCvDiag->stMeasure[inCnt].dwCamWidth = m_stRtCvImg->Width;
		m_stRtCvDiag->stMeasure[inCnt].dwCamHeight = m_stRtCvImg->Height;
		m_stRtCvDiag->stMeasure[inCnt].dwCamChannel = m_stRtCvImg->Channel;

		// --------------------------------------
		// TCY
		// --------------------------------------
		m_stRtCvDiag->stMeasure[inCnt].doTime[enRtCvDiagMeasureTimeResize] = GetCPUCounter();
		cv::resize(img, img, cv::Size(m_stRtCvImg->Width * m_stRtCvDiag->doResize, m_stRtCvImg->Height * m_stRtCvDiag->doResize));

		// --------------------------------------
		// O[XP[
		// --------------------------------------
		m_stRtCvDiag->stMeasure[inCnt].doTime[enRtCvDiagMeasureTimeGray] = GetCPUCounter();
		cv::cvtColor(img, img, cv::COLOR_BGR2GRAY);

		// --------------------------------------
		// GbWo
		// --------------------------------------
		m_stRtCvDiag->stMeasure[inCnt].doTime[enRtCvDiagMeasureTimeOpencv] = GetCPUCounter();
		cv::Canny(img, img, doThres1, doThres2);

		
		m_stRtCvDiag->stMeasure[inCnt].doTime[enRtCvDiagMeasureTimeEnd] = GetCPUCounter();



		__RUN__;
		// 񐔃CNg
		inCnt++;
		if (0 == (inCnt % 50))
		{
			printf("+ %04d\r", inCnt);
		}
		else
		{
			printf("-");
		}
	}
	printf("\n");
	printf("I$[%04d]RtCv Measure stop \n", __LINE__);

	__RUN__;
	// vʂۑ
	fnSaveRtCvMeasure();

	__RUN__;
}


/*****************************************************************************
*
* FUNCTION:			main
*
* DESCRIPTION:		C
*
*
\*****************************************************************************/
int			main(int argc, char* argv[])
{
	int				i;

	cout << "Hello, World! This is OpenCV for Windows program" << endl;

	fnStopWatchInit();

	// VXeNpX̕ۑ
	memset(szBootPath, 0x00, sizeof(szBootPath));
	for (i = (strlen(argv[0]) - 1); i >= 0; i--) {
		if (argv[0][i] == '\\') {
			break;
		}
	}
	memcpy(szBootPath, argv[0], i + 1);

	// g̃XbhvCIeB̓ftHgŃeXg
	//// XbhvCIeBɐݒ
	//SetPriorityClass(GetCurrentProcess(), REALTIME_PRIORITY_CLASS);
	//// g̃XbhvCIeB̕ύX
	//SetThreadPriority(GetCurrentThread(), 0);

	m_stRtCvDiag = (ST_RTCVDIAG*)malloc(sizeof(ST_RTCVDIAG));
	m_stRtCvImg = (ST_VIDEOCAPTURE_IMAGE*)malloc(sizeof(ST_VIDEOCAPTURE_IMAGE));

	char chKey[32];
	// L[͑҂ ... "e"ŃvOI
	for (;;)
	{
		printf("e:exit program ... ");
		gets(chKey);

		std::string srKey(chKey);
		if ("e" == srKey) { break; }

		else if ("201" == srKey) { fnKey201(); }


	}

	free(m_stRtCvDiag);
	free(m_stRtCvImg);

	printf("press any key ... ");
	gets_s(chKey, sizeof(chKey));
	return 0;
}